Select

Bootstrap Select

Note: We are transitioning MDB4 to a legacy version and focusing on developing MDB5. While we'll continue to support for the transition period, we encourage you to migrate to MDB5. We're offering a huge discount on MDB5 PRO to help with your transition, enabling you to leverage the full potential of the latest version. You can find more information here.
upgrade with discount

Bootstrap Material Select is a form control that, after a click displays a collapsable list of multiple values which can be used in forms, menus or surveys.

MDB provides you a variety of options and variations.


Default select

Custom select menus need only a custom class, .custom-select to trigger the custom styles. Custom styles are limited to the select’s initial appearance and cannot modify the option's due to browser limitations.

        
            
            <select class="browser-default custom-select">
              <option selected>Open this select menu</option>
              <option value="1">One</option>
              <option value="2">Two</option>
              <option value="3">Three</option>
            </select>
          
        
    

Material select MDB Pro component

Material Select requires an initialization. You have to add the .materialSelect() js code to the select element.

        
            

            <select class="mdb-select md-form">
              <option value="" disabled selected>Choose your option</option>
              <option value="1">Option 1</option>
              <option value="2">Option 2</option>
              <option value="3">Option 3</option>
            </select>

          
        
    
        
            
            // Material Select Initialization
            $(document).ready(function() {
              $('.mdb-select').materialSelect();
            });
          
        
    

You may also choose from small and large custom selects to match our similarly sized text inputs.

        
            
        <select class="browser-default custom-select custom-select-lg mb-3">
          <option selected>Open this select menu</option>
          <option value="1">One</option>
          <option value="2">Two</option>
          <option value="3">Three</option>
        </select>

        <select class="custom-select custom-select-sm">
          <option selected>Open this select menu</option>
          <option value="1">One</option>
          <option value="2">Two</option>
          <option value="3">Three</option>
        </select>
      
        
    

The multiple attribute is also supported:

        
            

        <select class="custom-select" multiple>
          <option selected>Open this select menu</option>
          <option value="1">One</option>
          <option value="2">Two</option>
          <option value="3">Three</option>
        </select>

      
        
    

As is the size attribute:

        
            

        <select class="custom-select" size="3">
          <option selected>Open this select menu</option>
          <option value="1">One</option>
          <option value="2">Two</option>
          <option value="3">Three</option>
        </select>

      
        
    

Overwriting a standard select

MDB overwrites a standard select to replace it with our Material Select. That's why before you can use it, you have to initialize Material Select by placing the following code in your project.

In addition, you will need a separate call for any dynamically generated select elements your page generates.

Initialization:

        
            
        // Material Select Initialization
        $(document).ready(function() {
          $('.mdb-select').materialSelect();
        });
      
        
    

Color variations MDB Pro component

You can use different colors for this element within the selection.

        
            

        <!--Blue select-->
        <select class="mdb-select md-form colorful-select dropdown-primary">
          <option value="1">Option 1</option>
          <option value="2">Option 2</option>
          <option value="3">Option 3</option>
          <option value="4">Option 4</option>
          <option value="5">Option 5</option>
        </select>
        <label class="mdb-main-label">Blue select</label>
        <!--/Blue select-->

      
        
    
        
            

        // Material Select Initialization
        $(document).ready(function() {
          $('.mdb-select').materialSelect();
        });
        
      
        
    

In order to change a select color use one of the following classes:

1. .dropdown-primary

2. .dropdown-danger

3. .dropdown-default

4. .dropdown-secondary

5. .dropdown-success

6. .dropdown-info

7. .dropdown-warning

8. .dropdown-ins

9. .dropdown-dark


Select with a search box MDB Pro component

        
            

        <select class="mdb-select md-form" searchable="Search here..">
          <option value="" disabled selected>Choose your country</option>
          <option value="1">USA</option>
          <option value="2">Germany</option>
          <option value="3">France</option>
          <option value="3">Poland</option>
          <option value="3">Japan</option>
        </select>

      
        
    
        
            

        // Material Select Initialization
        $(document).ready(function() {
          $('.mdb-select').materialSelect();
        });
        
      
        
    

Select with a label and search box MDB Pro component

        
            

        <select class="mdb-select md-form" searchable="Search here..">
          <option value="" disabled selected>Choose your country</option>
          <option value="1">USA</option>
          <option value="2">Germany</option>
          <option value="3">France</option>
          <option value="3">Poland</option>
          <option value="3">Japan</option>
        </select>
        <label class="mdb-main-label">Label example</label>

      
        
    
        
            

        // Material Select Initialization
        $(document).ready(function() {
          $('.mdb-select').materialSelect();
        });
        
      
        
    

Select with a secondary text MDB Pro component

        
            

          <select class="mdb-select md-form" searchable="Search here..">
            <option value="" disabled selected>Choose your car</option>
            <option value="2" data-secondary-text="Production year: 2012">Volkswagen Passat</option>
            <option value="3" data-secondary-text="Production year: 2017">Subaru Legacy</option>
            <option value="3" data-secondary-text="Production year: 2015">Hyundai Elantra</option>
            <option value="3" data-secondary-text="Production year: 2019">Honda Civic</option>
            <option value="3" data-secondary-text="Production year: 2016">Audi A6</option>
          </select>
  
        
        
    
        
            
  
          // Material Select Initialization
          $(document).ready(function() {
            $('.mdb-select').materialSelect();
          });
          
        
        
    

Multiple select MDB Pro component

        
            

        <select class="mdb-select md-form" multiple>
          <option value="" disabled selected>Choose your option</option>
          <option value="1">Option 1</option>
          <option value="2">Option 2</option>
          <option value="3">Option 3</option>
        </select>
        <label class="mdb-main-label">Example label</label>
        <button class="btn-save btn btn-primary btn-sm">Save</button>

      
        
    
        
            

        // Material Select Initialization
        $(document).ready(function() {
          $('.mdb-select').materialSelect();
        });
        
      
        
    

Multiselect variations

More multiselect examples and variations can be found in the Multiselect documentation


Options groups MDB Pro component

        
            

        <select class="mdb-select md-form">
          <optgroup label="team 1">
            <option value="1">Option 1</option>
            <option value="2">Option 2</option>
          </optgroup>
          <optgroup label="team 2">
            <option value="3">Option 3</option>
            <option value="4">Option 4</option>
          </optgroup>
        </select>
        <label class="mdb-main-label">Example label</label>

      
        
    
        
            

        // Material Select Initialization
        $(document).ready(function() {
          $('.mdb-select').materialSelect();
        });
        
      
        
    

Select with icons MDB Pro component

        
            

        <select class="mdb-select md-form">
          <option value="" disabled selected>Choose your option</option>
          <option value="" data-icon="https://mdbootstrap.com/img/Photos/Avatars/avatar-1.webp" class="rounded-circle">
            example
            1</option>
          <option value="" data-icon="https://mdbootstrap.com/img/Photos/Avatars/avatar-2.webp" class="rounded-circle">
            example
            2</option>
          <option value="" data-icon="https://mdbootstrap.com/img/Photos/Avatars/avatar-3.webp" class="rounded-circle">
            example
            1</option>
        </select>
        <label class="mdb-main-label">Example label</label>

      
        
    
        
            

        // Material Select Initialization
        $(document).ready(function() {
          $('.mdb-select').materialSelect();
        });
        
      
        
    

Disabled select MDB Pro component

By adding a disabled attribute to the select (or a particular option), you can make it unselectable.

        
            

        <!-- Disabled select-->
        <select class="mdb-select md-form" disabled>
          <option value="" disabled selected>Choose your option</option>
          <option value="1">Option 1</option>
          <option value="2">Option 2</option>
          <option value="3">Option 3</option>
        </select>
        <label class="disabled mdb-main-label">Example label</label>

        <!--Disabled option-->
        <select class="mdb-select md-form">
          <option value="" disabled selected>Choose your option</option>
          <option value="1" disabled>Disabled option</option>
          <option value="2">Option 2</option>
          <option value="3">Option 3</option>
        </select>
        <label class="mdb-main-label">Example label</label>

      
        
    
        
            

        // Material Select Initialization
        $(document).ready(function() {
          $('.mdb-select').materialSelect();
        });
        
      
        
    

Outline select MDB Pro component

Note warning: For now, an outline styling works correct only for Material Select (not Multiselect) with primary dropdown menu and with skins colors.

        
            

        <div class="row">
          <div class="col-md-6 select-outline">

            <select class="mdb-select md-form md-outline colorful-select dropdown-primary">
              <option value="" disabled selected>Choose your option</option>
              <option value="1">Option 1</option>
              <option value="2">Option 2</option>
              <option value="3">Option 3</option>
            </select>
            <label>Example label</label>

          </div>
        </div>

      
        
    
        
            

        .md-outline.select-wrapper+label {
          top: .5em !important;
          z-index: 2 !important;
        }

      
        
    
        
            

        // Material Select Initialization
        $(document).ready(function() {
          $('.mdb-select').materialSelect();
          $('.select-wrapper.md-form.md-outline input.select-dropdown').bind('focus blur', function () {
            $(this).closest('.select-outline').find('label').toggleClass('active');
            $(this).closest('.select-outline').find('.caret').toggleClass('active');
          });
        });

      
        
    

Updating/destroying Material Select MDB Pro component

To update the items inside the existing Material Select you can destroy it with the function below and then initialize it again.

        
            

        // Material Select Destroy
        $('.mdb-select').materialSelect({
          destroy: true
        });

      
        
    

Adding new options MDB Pro component

By adding an editable="true" attribute to the select, you can easily extend the options list.

        
            

        <select class="mdb-select md-form" editable="true" searchable="Search and add here...">
          <option value="" disabled selected>Choose your option</option>
          <option value="1">Option 1</option>
          <option value="2">Option 2</option>
          <option value="3">Option 3</option>
        </select>
        <label class="mdb-main-label">Example label</label>

      
        
    
        
            

        $(document).ready(function() {

          // Material Select
            $('.mdb-select').materialSelect({
          });
        })

      
        
    

Validation MDB Pro component

        
            

        <form class="needs-validation" novalidate>
          <select class="mdb-select validate md-form" searchable="Search here..">
            <option value="" disabled selected>Choose your country</option>
            <option value="1">USA</option>
            <option value="2">Germany</option>
            <option value="3">France</option>
            <option value="4">Poland</option>
            <option value="5">Japan</option>
          </select>
          <button class="btn btn-default btn-sm">Submit</button>
        </form>

      
        
    
        
            
        $(document).ready(function() {
          $('.mdb-select.validate').materialSelect({
            validate: true,
            labels: {
              validFeedback: 'Correct choice',
              invalidFeedback: 'Wrong choice'
            }
          });
          function validateSelect(e) {
            e.preventDefault();
            $('.needs-validation').addClass('was-validated');
            if ($('.needs-validation select').val() === null) {
              $('.needs-validation').find('.valid-feedback').hide();
              $('.needs-validation').find('.invalid-feedback').show();
              $('.needs-validation').find('.select-dropdown').val('').prop('placeholder', 'No countries selected')
            } else {
              $('.needs-validation').find('.valid-feedback').show();
              $('.needs-validation').find('.invalid-feedback').hide();
            }
          }
          $('.needs-validation select').on('change', e => validateSelect(e))
          $('.needs-validation').on('submit', e => validateSelect(e))
        });
      
        
    

Select options and attributes MDB Pro component

There is a plenty of options to customize the Material Select. All of them are described below. Important thing to note is that data attributes have higher priority than JS options passed to the .materialSelect() call. It means that if you will have data-placeholder="Please select a country" and JS option { placeholder: 'Choose country' }, then the value of data-placeholder will be displayed as it has higher priority. The exception is the id attribute which has higher priority than data-select-id as described below.

Data attribute Option name Type Default Description
- destroy boolean false If set to true destroys the Material Select wrapper
data-secondary-text secondaryText string false Additional text displayed inside an option
data-validate validate boolean false If set to true the select control will be validated when put into form element
data-select-id selectId string null If provided, this ID will be used instead of a random UUID to make Material Select elements unique. Note: if id attribute is provided, it has the highest priority
data-default-material-input defaultMaterialInput boolean false If set to true the select control will look like default Bootstrap select
data-fas-classes fasClasses string empty Space-separated list of FAS classes to add on the <i> element in the options list. Note: works only if data-fas attribute is provided with chosen FAS class value
data-far-classes farClasses string empty Space-separated list of FAR classes to add on the <i> element in the options list. Note: works only if data-far attribute is provided with chosen FAR class value
data-fab-classes fabClasses string empty Space-separated list of FAB classes to add on the <i> element in the options list. Note: works only if data-fab attribute is provided with chosen FAB class value
data-copy-classes-option copyClassesOption boolean false If set to true all classes added to the native <select> control will be copied to each option in the Material Select dropdown
data-label-select-all labels.selectAll string Select all The text which is displayed as option which selects all other options in the Multiselect
data-label-options-selected labels.optionsSelected string options selected The text which is displayed on the Multiselect when there are more than 5 (default) options selected, e.g. 7 options selected
data-label-valid-feedback labels.validFeedback string Ok The text which is displayed below the Material Select when the validate option is enabled and the select is valid
data-label-invalid-feedback labels.invalidFeedback string Incorrect value The text which is displayed below the Material Select when the validate option is enabled and the select is invalid
data-label-no-search-results labels.noSearchResults string No results The text which is displayed in the Searchable Select when there are no results
data-label-keyboard-active-class keyboardActiveClass string heavy-rain-gradient The class which is added to the options selected by the arrow keys (using keyboard)
data-placeholder placeholder string null The placeholder text which is displayed on the select if no value selected yet
data-visible-options visibleOptions number 5 The maximum number of options which are visible in the Material Select dropdown without scrolling. If set to -1, the limit is off
data-max-selected-options maxSelectedOptions number 5 The maximum number of comma-separated list of options displayed on the Multiselect. If a user selects more options than that value, the X options selected text will be displayed instead. If set to -1, the limit is off

Angular Bootstrap Select

Angular Select - Bootstrap 4 & Material Design

Angular Bootstrap select is a component that displays a collapsable list of multiple values which can be used in forms, menus or surveys.

MDB provides you a variety of options and variations.

This documentation may contain syntax introduced in the MDB Angular 9.3.0 and can be incompatible with previous versions. For old timepicker documentation please follow the link.

Live example

Default select

        
            
              <select class="browser-default custom-select">
                <option selected>Open this select menu</option>
                <option value="1">One</option>
                <option value="2">Two</option>
                <option value="3">Three</option>
              </select>
            
        
    

Material select MDB Pro component

        
            
              <div class="md-form">
                <mdb-select-2 placeholder="Choose your option" label="Example label">
                  <mdb-select-option *ngFor="let option of options" [value]="option.value">{{ option.label }}</mdb-select-option>
                </mdb-select-2>
              </div>
            
        
    
        
            
              import { Component } from '@angular/core';

              @Component({
                selector: 'basic-material-select-example',
                templateUrl: 'basic-material-select.html',
              })
              export class BasicMaterialSelectComponent {
                options = [
                  { value: '1', label: 'Option 1' },
                  { value: '2', label: 'Option 2' },
                  { value: '3', label: 'Option 3' },
                ];
              }
            
        
    

Multiple select MDB Pro component

        
            
          <div class="md-form">
            <mdb-select-2 [multiple]="true" placeholder="Choose your option" label="Example label">
              <mdb-select-option *ngFor="let option of options" [value]="option.value">{{ option.label }}</mdb-select-option>
            </mdb-select-2>
          </div>
        
        
    
        
            
          import { Component } from '@angular/core';

          @Component({
            selector: 'multiple-material-select-example',
            templateUrl: 'multiple-material-select.html',
          })
          export class MultipleMaterialSelectComponent {
            options = [
              { value: '1', label: 'Option 1' },
              { value: '2', label: 'Option 2' },
              { value: '3', label: 'Option 3' },
            ];
          }
        
        
    

Options groups MDB Pro component

        
            
          <div class="md-form">
            <mdb-select-2 placeholder="Choose your option" label="Example label">
              <mdb-option-group *ngFor="let group of groups" [label]="group.name">
                <mdb-select-option *ngFor="let option of group.options" [value]="option.value">{{ option.label }}</mdb-select-option>
              </mdb-option-group>
            </mdb-select-2>
          </div>
        
        
    
        
            
          import { Component } from '@angular/core';

          @Component({
            selector: 'options-material-select-example',
            templateUrl: 'options-material-select.html',
          })
          export class OptionsMaterialSelectComponent {
            groups = [
              {
                name: 'First group',
                options: [
                  {value: 'first-group-1', label: 'First Group Option 1'},
                  {value: 'first-group-2', label: 'First Group Option 2'},
                ]
              },
              {
                name: 'Second Group',
                options: [
                  {value: 'second-group-1', label: 'Second Group Option 1'},
                  {value: 'second-group-2', label: 'Second Group Option 2'},
                ]
              }
            ];
          }
        
        
    

Disabled select MDB Pro component

You can make your select unselectable, by adding [disabled]="disabled" to mdb-select.


        
            
          <div class="row">
            <div class="col-md-6">
              <div class="md-form">
                <mdb-select-2 [disabled]="disabled" placeholder="Choose your option" label="Example label">
                  <mdb-select-option *ngFor="let option of options" [value]="option.value">{{ option.label }}</mdb-select-option>
                </mdb-select-2>
              </div>
            </div>
            <div class="col-md-6">
              <div class="md-form">
                <mdb-select-2 placeholder="Choose your option" label="Example label">
                  <mdb-select-option *ngFor="let option of options" [value]="option.value" [disabled]="option.disabled">{{ option.label }}</mdb-select-option>
                </mdb-select-2>
              </div>
            </div>
          </div>
        
        
    
        
            
          import { Component } from '@angular/core';

          @Component({
            selector: 'disabled-material-select-example',
            templateUrl: 'disabled-material-select.html',
          })
          export class DisabledMaterialSelectComponent {
            disabled = true;

            options = [
              { value: '1', label: 'Option 1', disabled: true },
              { value: '2', label: 'Option 2', disabled: false },
              { value: '3', label: 'Option 3', disabled: false },
            ];
          }
        
        
    

Template-driven forms MDB Pro component

In this section, you will find on how to use our select component in template-driven forms.

Remember to import the FormsModule into your app.module.ts file.

Preselected value

Bind in the two-way ngModel from component.html with the selectedValue in the component.ts file

        
            
          <div class="md-form">
            <mdb-select-2 placeholder="Choose your option" label="Example label" [(ngModel)]="selectedValue">
              <mdb-select-option *ngFor="let option of options" [value]="option.value">{{ option.label }}</mdb-select-option>
            </mdb-select-2>
          </div>
        
        
    
        
            
          import { Component } from '@angular/core';

          @Component({
            selector: 'defaultvalue-material-select-example',
            templateUrl: 'defaultvalue-material-select.html',
          })
          export class DefaultValueMaterialSelectComponent {
            options = [
              { value: '1', label: 'Option 1' },
              { value: '2', label: 'Option 2' },
              { value: '3', label: 'Option 3' },
            ];

            selectedValue = '1';
        
        
    

Get selected value

Get selected value with the ngModelChange event, which fires every time you select an option.

        
            
          <div class="md-form">
            <mdb-select-2 placeholder="Choose your option" label="Example label" (ngModelChange)="getSelectedValue($event)" [ngModel]="selectedValue">
              <mdb-select-option *ngFor="let option of options" [value]="option.value">{{ option.label }}</mdb-select-option>
            </mdb-select-2>
          </div>
        
        
    
        
            
          import { Component, OnInit } from '@angular/core';

          @Component({
            selector: 'getvalue-material-select-example',
            templateUrl: 'getvalue-material-select.html',
          })
          export class GetValueMaterialSelectComponent implements OnInit {
            options = [
              { value: '1', label: 'Option 1' },
              { value: '2', label: 'Option 2' },
              { value: '3', label: 'Option 3' },
            ];

            selectedValue = '1';

            getSelectedValue(value: any) {
              console.log('Selected value:', value);
            }
          }
        
        
    

Reactive forms MDB Pro component

In this section, you will find information on how to use our select component in reactive forms.

Remember to import the ReactiveFormsModule into your app.module.ts file.

Preselected value

Set the default value in FormControl

        
            
          <div class="md-form">
            <mdb-select-2 placeholder="Choose your option" label="Example label" [formControl]="selectControl">
              <mdb-select-option *ngFor="let option of options" [value]="option.value">{{ option.label }}</mdb-select-option>
            </mdb-select-2>
          </div>
        
        
    
        
            
          import { Component } from '@angular/core';
          import { FormControl } from '@angular/forms';

          @Component({
            selector: 'defaultvalue-material-select-example',
            templateUrl: 'defaultvalue-material-select.html',
          })
          export class DefaultValueMaterialSelectComponent {
            selectControl = new FormControl('1');

            options = [
              { value: '1', label: 'Option 1' },
              { value: '2', label: 'Option 2' },
              { value: '3', label: 'Option 3' },
            ];
          }
        
        
    

Get selected value

Get the selected value with the reactive forms valueChanged method.

        
            
          <div class="md-form">
            <mdb-select-2 placeholder="Choose your option" label="Example label" [formControl]="selectControl">
              <mdb-select-option *ngFor="let option of options" [value]="option.value">{{ option.label }}</mdb-select-option>
            </mdb-select-2>
          </div>
        
        
    
        
            
          import { Component, OnInit } from '@angular/core';
          import { FormControl } from '@angular/forms';

          @Component({
            selector: 'getvalue-material-select-example',
            templateUrl: 'getvalue-material-select.html',
          })
          export class GetValueMaterialSelectComponent implements OnInit {
            selectControl = new FormControl('1');

            options = [
              { value: '1', label: 'Option 1' },
              { value: '2', label: 'Option 2' },
              { value: '3', label: 'Option 3' },
            ];

            ngOnInit() {
              this.selectControl.valueChanges.subscribe((value: any) => {
                console.log('Selected value:', value);
              })
            }
          }
        
        
    

Object as option value

        
            
          <div class="md-form">
            <mdb-select-2 placeholder="Choose your option" label="Example label" [(ngModel)]="selectedValue" [compareWith]="compareFn">
              <mdb-select-option *ngFor="let option of options" [value]="option">{{ option.label }}</mdb-select-option>
            </mdb-select-2>
          </div>
        
        
    
        
            
          import { Component } from '@angular/core';
          @Component({
          selector: 'basic-material-select-example',
          templateUrl: 'basic-material-select.html',
          })
          export class BasicMaterialSelectComponent {
            options = [
              { value: '1', label: 'Option 1' },
              { value: '2', label: 'Option 2' },
              { value: '3', label: 'Option 3' },
            ];
            selectedValue = { value: '2', label: 'Option 2' };
            compareFn(o1: any, o2: any): boolean {
              return o1 && o2 ? o1.value === o2.value : o1 === o2;
            }
          }
        
        
    

Outline version MDB Pro component

Use the [outline] input and md-outline class to make the Material Select outline like in Material 2.0.

        
            
          <div class="md-form md-outline">
            <mdb-select-2 [outline]="true" placeholder="Choose your option" label="Example label">
              <mdb-select-option *ngFor="let option of options" [value]="option.value">{{ option.label }}</mdb-select-option>
            </mdb-select-2>
          </div>
        
        
    
        
            
          import { Component } from '@angular/core';

          @Component({
            selector: 'outline-select',
            templateUrl: 'outline-select.component.html',
          })
          export class OutlineSelectComponent {
            options = [
              { value: '1', label: 'Option 1' },
              { value: '2', label: 'Option 2' },
              { value: '3', label: 'Option 3' },
            ];
          }
        
        
    

Angular Select - API

In this section you will find informations about required modules and available inputs, outputs, methods and events of select component.

This documentation may contain syntax introduced in the MDB Angular 9.3.0 and can be incompatible with previous versions. For old timepicker documentation please follow the link.

Live example

Modules used

In order to speed up your application, you can choose to import only the modules you actually need, instead of importing the entire MDB Angular library. Remember that importing the entire library, and immediately afterwards a specific module, is bad practice, and can cause application errors.

API Reference for MDB Angular Select:
        
            
          import { MdbSelectModule } from 'ng-uikit-pro-standard';
          import { BrowserAnimationsModule } from '@angular/platform-browser/animations';
        
        
    

Components

Select

Selector: mdb-select-2

Type: MdbSelectComponent

Select filter

Selector: mdb-select-filter

Type: MdbSelectFilterComponent


Inputs

Name Type Default Description Example
dropdownClass string ' ' Pass here a css class which you want to add on the internal element of mdb-select [dropdownClass]="'blue'"
allowClear boolean false Whether button for removing selected options should be visible [allowClear]="true"
disabled boolean false Allow to disable select input [disabled]="true"
label string - Adds select label [label]="'Example label'"
multiple boolean false Enables selecting multiple options [multiple]="true"
notFoundMsg string 'No results found' Defines custom not found message for select search box [notFoundMsg]="'Country not found'"
placeholder string ' ' Defines placeholder for mdb-select element placeholder="Text placeholder"
tabindex number 0 Changes tabindex of the component [tabindex]="-1"
visibleOptions number 4 Changes number of visible options in options list [visibleOptions]="2"
optionHeight number 48 Changes the single option height vavlue optionHeight="50"
outline boolean false Changes the appearance of the mdb-select to the outline. [outline]="true"

Outputs

Name Type Description Example
closed EventEmitter<any> Event fired when the select is closed (closed)="selectClosed($event)"
opened EventEmitter<any> Event fired when the select is opened (opened)="selectOpened($event)"
valueChanged EventEmitter<any> Event fired when the select value is changed (changed)="valueChanged($event)"

Methods

You can get access to the select methods from another component. Add template reference variable to your mdb-select-2 component in the HTML file

<mdb-select-2 #select></mdb-select-2>

Then in your typescript file use the @ViewChild decorator to get access to the MdbSelectComponent methods

@ViewChild('select', { static: true }) select: MdbSelectComponent

MdbSelectComponent
Name Description Example
close Closes the select dropdown this.select.close()
open Opens the select dropdown this.select.open()

Angular Select - examples & customization

This documentation may contain syntax introduced in the MDB Angular 9.3.0 and can be incompatible with previous versions. For old timepicker documentation please follow the link.

Live example

Color variations MDB Pro component

        
            
          <div class="md-form">
            <mdb-select-2 placeholder="Choose your option" label="Example label" [dropdownClass]="'mdb-select-dropdown-colorful mdb-select-dropdown-primary'">
              <mdb-select-option *ngFor="let option of options" [value]="option.value">{{ option.label }}</mdb-select-option>
            </mdb-select-2>
          </div>
        
        
    
        
            
          import { Component } from '@angular/core';

          @Component({
            selector: 'color-material-select-example',
            templateUrl: 'color-material-select.html',
          })
          export class ColorMaterialSelectComponent {
            options = [
              { value: '1', label: 'Option 1' },
              { value: '2', label: 'Option 2' },
              { value: '3', label: 'Option 3' },
            ];
          }
        
        
    

In order to change a select color use one of the following classes:

1. .mdb-select-dropdown-primary

2. .mdb-select-dropdown-danger

3. .mdb-select-dropdown-default

4. .mdb-select-dropdown-secondary

5. .mdb-select-dropdown-success

6. .mdb-select-dropdown-info

7. .mdb-select-dropdown-warning

8. .mdb-select-dropdown-ins

9. .mdb-select-dropdown-dark


Select with icons MDB Pro component

        
            
          <div class="md-form">
            <mdb-select-2 placeholder="Choose your option" label="Example label" [dropdownClass]="'mdb-select-dropdown-colorful mdb-select-dropdown-primary'">
              <mdb-select-option *ngFor="let option of options" [value]="option">
                <div class="d-flex justify-content-between align-items-center">
                  <span>{{ option.label }}</span>
                  <img [src]="option.icon" class="rounded-circle" height="34" width="34">
                </div>
              </mdb-select-option>
            </mdb-select-2>
          </div>
        
        
    
        
            
          import { Component } from '@angular/core';

          @Component({
            selector: 'icons-material-select-example',
            templateUrl: 'icons-material-select.html',
          })
          export class IconsMaterialSelectComponent {
            options = [
              { value: '1', label: 'Option 1', icon: 'https://mdbootstrap.com/img/Photos/Avatars/avatar-1.webp' },
              { value: '2', label: 'Option 2', icon: 'https://mdbootstrap.com/img/Photos/Avatars/avatar-2.webp' },
              { value: '3', label: 'Option 3', icon: 'https://mdbootstrap.com/img/Photos/Avatars/avatar-3.webp' },
            ];
          }
        
        
    


Select with custom template MDB Pro component

        
            
          <div class="md-form">
            <mdb-select-2 [outline]="true" placeholder="Choose your option" label="Example label">
              <mdb-select-option *ngFor="let option of options" [value]="option.value">{{ option.label }}</mdb-select-option>
              <button mdbBtn color="primary" size="sm" block="true">Button</button>
            </mdb-select-2>
          </div>
        
        
    
        
            
          import { Component } from '@angular/core';

          @Component({
            selector: 'select-with-template',
            templateUrl: 'select-with-template.component.html',
          })
          export class SelectWithTemplateComponent {
            options = [
              { value: '1', label: 'Option 1' },
              { value: '2', label: 'Option 2' },
              { value: '3', label: 'Option 3' },
            ];
          }

Vue Bootstrap Select

Vue Select - Bootstrap 4 & Material Design

Note: This documentation is for an older version of Bootstrap (v.4). A newer version is available for Bootstrap 5. We recommend migrating to the latest version of our product - Material Design for Bootstrap 5.
Go to docs v.5

Vue Bootstrap material select is a form control which after a click displays a collapsable list of multiple values which can be used in forms, menus or surveys.

MDB provides you a variety of options and variations.

This documentation may contain syntax introduced in the MDB Vue 6.0.0 and can be not compatible with previous versions. See legacy docs.

Vue live preview

Default select

Default Select doesn't require an initialization. You only need to add a .browser-default class to the select element.

        
            
          <template>
            <select class="browser-default custom-select">
              <option selected>Open this select menu</option>
              <option value="1">One</option>
              <option value="2">Two</option>
              <option value="3">Three</option>
            </select>
          </template>
          
        
    

Material select MDB Pro component

        
            
            <template>
              <mdb-container>
                <mdb-select v-model="basicOptions" placeholder="Select an option" label="" />
              </mdb-container>
            </template>
            
        
    
        
            
            <script>
              import {
                mdbSelect,
                mdbContainer
              } from "mdbvue";
              export default {
                name: "SelectPage",
                components: {
                  mdbSelect,
                  mdbContainer
                },
                data() {
                  return {
                    basicOptions: [{
                        text: "Option nr 1",
                        value: "Option 1"
                      },
                      {
                        text: "Option nr 2",
                        value: "Option 2"
                      },
                      {
                        text: "Option nr 3",
                        value: "Option 3"
                      }
                    ]
                  };
                }
              };
            </script>
            
        
    

Default input customization

Before we move on to discuss the Material Design text input we all here cherish & love, it could be worth to step back for a second and briefly go over features of plain old Bootstrap input.

You may also choose from small and large custom selects to match our similarly sized text inputs.

        
            
      <template>
        <div>
          <select class="browser-default custom-select custom-select-lg mb-3">
            <option selected>Open this select menu</option>
            <option value="1">One</option>
            <option value="2">Two</option>
            <option value="3">Three</option>
          </select>
          <select class="custom-select custom-select-sm">
            <option selected>Open this select menu</option>
            <option value="1">One</option>
            <option value="2">Two</option>
            <option value="3">Three</option>
          </select>
        </div>
      </template>
      
        
    

The multiple attribute is also supported:

        
            
      <template>
        <select class="custom-select" multiple>
          <option selected>Open this select menu</option>
          <option value="1">One</option>
          <option value="2">Two</option>
          <option value="3">Three</option>
        </select>
      </template>
      
        
    

As is the size attribute:

        
            
      <template>
        <select class="custom-select" size="3">
          <option selected>Open this select menu</option>
          <option value="1">One</option>
          <option value="2">Two</option>
          <option value="3">Three</option>
        </select>
      </template>
      
        
    

Color variations MDB Pro component

        
            
        <template>
          <mdb-container>
            <mdb-select color="primary" v-model="colorOptions" label="Blue select" />
          </mdb-container>
        </template>
        
        
    
        
            
        <script>
          import {
            mdbSelect,
            mdbContainer
          } from "mdbvue";
          export default {
            name: "SelectPage",
            components: {
              mdbSelect,
              mdbContainer
            },
            data() {
              return {
                colorOptions: [{
                    text: "Option nr 1",
                    value: "Option 1",
                    selected: true
                  },
                  {
                    text: "Option nr 2",
                    value: "Option 2"
                  },
                  {
                    text: "Option nr 3",
                    value: "Option 3"
                  },
                  {
                    text: "Option nr 4",
                    value: "Option 4"
                  },
                  {
                    text: "Option nr 5",
                    value: "Option 5"
                  }
                ]
              };
            }
          };
        </script>
        
        
    

In order to change a select color use one of the following color props:

1. primary

2. danger

3. default

4. secondary

5. success

6. info

7. warning

8. lime

9. pink


Select with search box MDB Pro component

        
            
        <template>
          <mdb-container>
            <mdb-select search v-model="searchOptions" placeholder="Choose your country" />
          </mdb-container>
        </template>
        
        
    
        
            
        <script>
          import {
            mdbSelect,
            mdbContainer
          } from 'mdbvue';
          export default {
            name: 'SelectPage',
            components: {
              mdbSelect,
              mdbContainer
            },
            data() {
              return {
                searchOptions: [{
                    text: 'Option nr 1',
                    value: 'Option 1'
                  },
                  {
                    text: 'Option nr 2',
                    value: 'Option 2'
                  },
                  {
                    text: 'Option nr 3',
                    value: 'Option 3'
                  },
                  {
                    text: 'Option nr 4',
                    value: 'Option 4'
                  },
                  {
                    text: 'Option nr 5',
                    value: 'Option 5'
                  }
                ]
              };
            }
          }
        </script>
        
        
    
        
            
        <script>
          import {
            mdbSelect,
            mdbContainer
          } from "mdbvue";
          export default {
            name: "SelectPage",
            components: {
              mdbSelect,
              mdbContainer
            },
            data() {
              return {
                searchOptions: [{
                    text: "Option nr 1",
                    value: "Option 1"
                  },
                  {
                    text: "Option nr 2",
                    value: "Option 2"
                  },
                  {
                    text: "Option nr 3",
                    value: "Option 3"
                  },
                  {
                    text: "Option nr 4",
                    value: "Option 4"
                  },
                  {
                    text: "Option nr 5",
                    value: "Option 5"
                  }
                ]
              };
            }
          };
        </script>
        
        
    

Select with label and search box MDB Pro component

        
            
        <template>
          <mdb-container>
            <mdb-select search v-model="labelOptions" label="Example label" placeholder="Choose your option" />
          </mdb-container>
        </template>
        
        
    
        
            
        <script>
          import {
            mdbSelect,
            mdbContainer
          } from "mdbvue";
          export default {
            name: "SelectPage",
            components: {
              mdbSelect,
              mdbContainer
            },
            data() {
              return {
                labelOptions: [{
                    text: "Option nr 1",
                    value: "Option 1"
                  },
                  {
                    text: "Option nr 2",
                    value: "Option 2"
                  },
                  {
                    text: "Option nr 3",
                    value: "Option 3"
                  },
                  {
                    text: "Option nr 4",
                    value: "Option 4"
                  },
                  {
                    text: "Option nr 5",
                    value: "Option 5"
                  }
                ]
              };
            }
          };
        </script>
        
        
    

Search with custom filtering MDB Pro component

        
            
        <template>
          <mdb-container>
            <mdb-select search :options="customSearchOptions" label="Custom search"
              :filter="(text, search) => { return text.includes(search)}" />
          </mdb-container>
        </template>
        
        
    
        
            
        <script>
          import {
            mdbSelect,
            mdbContainer
          } from "mdbvue";
          export default {
            name: "SelectPage",
            components: {
              mdbSelect,
              mdbContainer
            },
            data() {
              return {
                customSearchOptions: [{
                    text: "option",
                    value: "Option 1"
                  },
                  {
                    text: "Option",
                    value: "Option 2"
                  },
                  {
                    text: "OPTION",
                    value: "Option 3"
                  },
                ],
              };
            }
          };
        </script>
        
        
    

Select with default value MDB Pro component

        
            
        <template>
          <mdb-container>
            <mdb-select v-model="options" label="Example label" />
          </mdb-container>
        </template>
        
        
    
        
            
        <script>
          import {
            mdbSelect,
            mdbContainer
          } from "mdbvue";
          export default {
            name: "SelectPage",
            components: {
              mdbSelect,
              mdbContainer
            },
            data() {
              return {
                options: [{
                    text: "Option nr 1",
                    value: "Option 1",
                    selected: true
                  },
                  {
                    text: "Option nr 2",
                    value: "Option 2"
                  },
                  {
                    text: "Option nr 3",
                    value: "Option 3"
                  },
                  {
                    text: "Option nr 4",
                    value: "Option 4"
                  },
                  {
                    text: "Option nr 5",
                    value: "Option 5"
                  }
                ]
              };
            }
          };
        </script>
        
        
    

Multiselect variations

More multiselect examples and variations you will find in the Multiselect documentation


Multiple select MDB Pro component

        
            
        <template>
          <mdb-container>
            <mdb-select multiple selectAll v-model="multiOptions" label="Example label"
              placeholder="choose your option" />
          </mdb-container>
        </template>
        
        
    
        
            
        <script>
          import {
            mdbSelect,
            mdbContainer
          } from "mdbvue";
          export default {
            name: "SelectPage",
            components: {
              mdbSelect,
              mdbContainer
            },
            data() {
              return {
                multiOptions: [{
                    text: "Option nr 1",
                    value: "Option 1"
                  },
                  {
                    text: "Option nr 2",
                    value: "Option 2"
                  },
                  {
                    text: "Option nr 3",
                    value: "Option 3"
                  },
                  {
                    text: "Option nr 4",
                    value: "Option 4"
                  },
                  {
                    text: "Option nr 5",
                    value: "Option 5"
                  }
                ]
              };
            }
          };
        </script>
        
        
    

Multiselect variations

More multiselect examples and variations you will find in the Multiselect documentation


Options groups MDB Pro component

Separate groups of options using disabled option.

        
            
        <template>
          <mdb-container>
            <mdb-select v-model="groupOptions" label="Example label" />
          </mdb-container>
        </template>
        
        
    
        
            
        <script>
          import {
            mdbSelect,
            mdbContainer
          } from "mdbvue";
          export default {
            name: "SelectPage",
            components: {
              mdbSelect,
              mdbContainer
            },
            data() {
              return {
                groupOptions: [{
                    text: "team 1",
                    value: null,
                    disabled: true,
                    optgroup: true
                  },
                  {
                    text: "Option nr 1",
                    value: "Option 1",
                    selected: true
                  },
                  {
                    text: "Option nr 2",
                    value: "Option 2"
                  },
                  {
                    text: "team 2",
                    value: null,
                    disabled: true,
                    optgroup: true
                  },
                  {
                    text: "Option nr 3",
                    value: "Option 3"
                  },
                  {
                    text: "Option nr 4",
                    value: "Option 4"
                  }
                ]
              };
            }
          };
        </script>
        
        
    

Select with icons MDB Pro component

        
            
        <template>
          <mdb-container>
            <mdb-select v-model="iconOptions" label="Example label" placeholder="Choose your option" />
          </mdb-container>
        </template>
        
        
    
        
            
        <script>
          import {
            mdbSelect,
            mdbContainer
          } from "mdbvue";
          export default {
            name: "SelectPage",
            components: {
              mdbSelect,
              mdbContainer
            },
            data() {
              return {
                iconOptions: [{
                    text: "Option nr 1",
                    value: "Option 1",
                    icon: "https://mdbootstrap.com/img/Photos/Avatars/avatar-1.webp"
                  },
                  {
                    text: "Option nr 2",
                    value: "Option 2",
                    icon: "https://mdbootstrap.com/img/Photos/Avatars/avatar-2.webp"
                  },
                  {
                    text: "Option nr 3",
                    value: "Option 3",
                    icon: "https://mdbootstrap.com/img/Photos/Avatars/avatar-3.webp"
                  }
                ]
              };
            }
          };
        </script>
        
        
    

Disabled select MDB Pro component

By adding a disabled attribute to the select (or particular option), you can make it unselectable.

        
            
        <template>
          <mdb-container>
            <mdb-select disabled v-model="disabledOptions" label="Example label" />
            <mdb-select v-model="disabledOptions" label="Example label" />
          </mdb-container>
        </template>
        
        
    
        
            
        <script>
          import {
            mdbSelect,
            mdbContainer
          } from 'mdbvue';
          export default {
            name: 'SelectPage',
            components: {
              mdbSelect,
              mdbContainer
            },
            data() {
              return {
                disabledOptions: [{
                    text: 'Disabled option',
                    value: 'Disabled',
                    disabled: true
                  },
                  {
                    text: 'Option nr 2',
                    value: 'Option 2'
                  },
                  {
                    text: 'Option nr 3',
                    value: 'Option 3'
                  }
                ]
              };
            }
          }
        </script>
        
        
    
        
            
        <script>
          import {
            mdbSelect,
            mdbContainer
          } from "mdbvue";
          export default {
            name: "SelectPage",
            components: {
              mdbSelect,
              mdbContainer
            },
            data() {
              return {
                disabledOptions: [{
                    text: "Option nr 1",
                    value: "Option 1"
                  },
                  {
                    text: "Option nr 2",
                    value: "Option 2"
                  },
                  {
                    text: "Option nr 3",
                    value: "Option 3"
                  },
                  {
                    text: "Option nr 4",
                    value: "Option 4"
                  },
                  {
                    text: "Option nr 5",
                    value: "Option 5"
                  }
                ]
              };
            }
          };
        </script>
        
        
    

Outline select MDB Pro component

        
            
        <template>
          <mdb-row>
            <mdb-col sm="6">
              <mdb-select outline v-model="outlineOptions" label="Example label" placeholder="choose your option" />
            </mdb-col>
          </mdb-row>
        </template>
        
        
    
        
            
        <script>
          import {
            mdbSelect,
            mdbRow,
            mdbCol
          } from "mdbvue";
          export default {
            name: "SelectPage",
            components: {
              mdbSelect,
              mdbRow,
              mdbCol
            },
            data() {
              return {
                outlineOptions: [{
                    text: "Option nr 1",
                    value: "Option 1"
                  },
                  {
                    text: "Option nr 2",
                    value: "Option 2"
                  },
                  {
                    text: "Option nr 3",
                    value: "Option 3"
                  },
                  {
                    text: "Option nr 4",
                    value: "Option 4"
                  },
                  {
                    text: "Option nr 5",
                    value: "Option 5"
                  }
                ]
              };
            }
          };
        </script>
        
        
    

Data from API MDB Pro component

You can easily add data from an API to Select by using axios client.

        
            
        <template>
          <div>
            <mdb-select v-model="axiosOptions" label="Choose country" />
            Selected country code: {{ this.selectedData }}
          </div>
        </template>
        
        
    
        
            
        <script>
          import {
            mdbSelect
          } from "mdbvue";
          import axios from "axios";
          export default {
            name: "SelectPage",
            components: {
              mdbSelect
            },
            computed: {
              selectedData() {
                let response = this.axiosOptions.find(option => {
                  return option.selected === true;
                });
                if (response) {
                  return response.value;
                }
                return "Country is not selected";
              }
            },
            data() {
              return {
                axiosOptions: []
              };
            },
            mounted() {
              axios
                .get("https://restcountries.eu/rest/v2/region/europe")
                .then(response => {
                  for (let i = 1; i <= 10; i++) {
                    this.axiosOptions.push({
                      text: response.data[i].name,
                      value: response.data[i].alpha3Code
                    });
                  }
                });
            }
          };
        </script>
        
        
    


Data from API - multiple selects MDB Pro component

In the example below, the options of the second select are fetched from API depending on the first one's value.

        
            
        <template>
          <div>
            <mdb-select v-model="axiosOptions" label="Choose country" resetBtn @change="populateLanguageSelect" />
            <mdb-select :disabled="disableLanguageSelect" v-model="languageOptions" label="Choose language" />
            <p>Selected country code: <strong>{{ selectedData }}</strong></p>
            <p>Selected language: <strong>{{ selectedLanguage }}</strong></p>
          </div>
        </template>
        
        
    
        
            
        <script>
          import {
            mdbSelect
          } from "mdbvue";
          import axios from "axios";
          export default {
            name: "SelectPage",
            components: {
              mdbSelect
            },
            computed: {
              selectedData() {
                let response = this.axiosOptions.find(option => {
                  return option.selected === true;
                });
                if (response) {
                  return response.value;
                }
                return "Country is not selected";
              },
              selectedLanguage() {
                const selectedOption = this.languageOptions.find(option => option.selected);
                return selectedOption ? selectedOption.value : "Language not selected";
              },
            },
            data() {
              return {
                axiosOptions: [],
                languageOptions: [],
                disableLanguageSelect: false,
              };
            },
            methods: {
              populateLanguageSelect(code) {
                if (code) {
                  fetch(`https://restcountries.eu/rest/v2/alpha/${code}`).then(resp => resp.json()).then(resp => {
                    this.languageOptions = resp.languages.map((language, i) => ({
                      value: language.name,
                      text: language.name,
                      selected: i === 0
                    }))
                  });
                  this.disableLanguageSelect = false;
                } else {
                  this.languageOptions = [];
                  this.disableLanguageSelect = true;
                }
              },
            },
            mounted() {
              axios
                .get("https://restcountries.eu/rest/v2/region/europe")
                .then(response => {
                  this.axiosOptions = response.data.map(entry => {
                    return {
                      text: entry.name,
                      value: entry.alpha3Code,
                    }
                  })
                });
            }
          };
        </script>
        
        
    

Reactivity in Depth MDB Pro component

Due to the limitations of modern JavaScript (and the abandonment of Object.observe), Vue cannot detect property addition or deletion.

Vue does not allow dynamically adding new root-level reactive properties to an already created instance. However, it’s possible to add reactive properties to a nested object using the Vue.set(object, propertyName, value) method. This method can also be applied for dynamic options selecting in our mdbSelect component.

        
            
          selectOption(key) {
            this.basicOptions.forEach(option => {
              option.selected = false;
            });
            this.$set(this.basicOptions[key],
              "selected", true);
            this.basicOptions.sort();
          }
        
        
    

Select - API

In this section you will find advanced information about the Select component. You will learn which modules are required in this component, what are the possibilities of configuring the component, and what events and methods you can use in working with it.


Import statement

        
            
      <script>
        import {
          mdbSelect
        } from "mdbvue";
      </script>
      
        
    

API Reference: Properties

Name Type Default Description Example
caretClass String Allows defining caret classes <mdb-select caretClass="..." ... />
caretStyle String Allows defining caret styles <mdb-select caretStyle="..." ... />
color String default Defines select hover color <mdb-select color="secondary" ... />
disabled Boolean false Disables select or each option <mdb-select disabled ... />
label String Changes input's label <mdb-select label="Example label" ... />
limitPlaceholder String 'options selected' Changes default placeholder for more than 5 options <mdb-select limitPlaceholder="selected" ... />
multiple Boolean false Allows multiple sellection <mdb-select multiple ... />
search Boolean false Adding search input inside dropdown menu <mdb-select search ... />
searchPlaceholder String 'Search here...' Defines search placeholder <mdb-select searchPlaceholder="Search" ... />
selectAll Boolean false Adding select all option <mdb-select selectAll ... />
selectAllPlaceholder String 'Select all' Changes select all option default value <mdb-select selectAllPlaceholder="..." ... />
wrapperClass String Allows defining wrapper classes <mdb-select wrapperClass="..." ... />
wrapperStyle String Allows defining wrapper styles <mdb-select wrapperStyle="..." ... />
validation Boolean false Enables default validation <mdb-select validation ... />
customValidation Boolean false Enables custom validation <mdb-select customValidation ... />
isValid Boolean false Custom validation check <mdb-select :isValid="true" ... />
validFeedback [String, Boolean] false Valid feedback label <mdb-select validFeedback="Correct" ... />
invalidFeedback [String, Boolean] false Invalid feedback label <mdb-select :invalidFeedback="Incorrect" ... />
outline Boolean Changes material select to outline style <mdb-select outline ... />
bg Boolean Sets design to animated border with background <mdb-select bg ... />
placeholder String Sets a placeholder in select's input field <mdb-select placeholder="placeholder" ... />
icon String Adds an icon <mdb-select icon="envelope" ... />
iconClass String Adds custom classes to an icon <mdb-select icon="envelope" iconClass="purple-text" ... />
far Boolean Changes icon's style to regular <mdb-select icon="..." far ... />
fal Boolean Changes icon's style to light <mdb-select icon="..." fal ... />
fab Boolean Changes icon's style to brands <mdb-select icon="..." fab ... />
scroll Boolean true Enables scrolling the dropdown's content <mdb-select scroll />
visibleOptions Number 4 Indicates maximum number of options visible in the dropwdown with scroll enabled <mdb-select :visibleOptions="6" />
flipOnScroll Boolean true If set to true, select will adjust its position while scroll/resize events <mdb-select flipOnScroll />
resultText String no results Information showed in search dropdown when nothing was found <mdb-select searcg resultText="Nothing to show!" />
show Boolean Prop which allow to toggle dropdown from outside <mdb-select :show="toggleDropdown" />
resetBtn Boolean false Shows button which can be used to reset select to its initial state <mdb-select resetBtn />
disableFilter Boolean false Disables the default filtering functionality - useful for async API calls made inside a @search handler <mdb-select @search="handleSeach" disableFilter />
top Boolean false Opens the dropdown on the top by default <mdb-select top />
apoBodypendT Boolean false Appends the select's dropdown to the end of the document <mdb-select append-to-body />
filter Function (text, search) => { return text.toLowerCase().includes(search.toLowerCase()) Function used to filter search results <mdb-select :filter="(text, search) => { return text === search }" />

API Reference: Methods

Name Parameters Description Example
v-on:getValue value, text Returns select value and text. Use this method to handle select state changes. <mdb-select @getValue="getSelectValue" />
validate Validate select. <mdb-select v-model="options" validation ref="select" /> <mdb-btn size="sm" color="primary" @click.native="$refs.select.validate()">Validate</mdb-btn>
v-on:focus e Emitted on input's native focus event, meaning when the field gains focus. <mdb-select @focus="onFocus" />
v-on:blur e Emitted on input's native blur event, meaning when the field looses focus. <mdb-select @blur="onBlur" />
v-on:toggleSelect Boolean Emitted when dropdown is toggled <mdb-select :show="showDropdown" @toggleSelect="showDropdown = $event" />
v-on:search Boolean Emits a value of a search input <mdb-select search @search="..." />

API Reference: Slots

Name Description Example
v-slot:footer Allows to insert a save btn in the multi select's footer <mdb-select multiple> <template #footer> ... </template></mdb-select>

React Bootstrap Select

React Select - Bootstrap 4 & Material Design

Note: This documentation is for an older version of Bootstrap (v.4). A newer version is available for Bootstrap 5. We recommend migrating to the latest version of our product - Material Design for Bootstrap 5.
Go to docs v.5

Bootstrap material select is a form control, that after the click displays a collapsible list of multiple values which can be used in forms, menus or surveys.

Select enables you to use and arrow keys to navigate through options and use key to select required option (works for stateful select).


Basic example

Default Select

Default styling for Bootstrap Select component

        
            
            import React, { Component } from 'react';

            class SelectPage extends Component {
              render () {
                return(
                  <div>
                    <select className="browser-default custom-select">
                      <option>Choose your option</option>
                      <option value="1">Option 1</option>
                      <option value="2">Option 2</option>
                      <option value="3">Option 3</option>
                    </select>
                  </div>
                );
              }
            }

            export default SelectPage;
           
        
    

Material Select MDB Pro component

Material Design styling for Bootstrap Select component

        
            
              import React, { Component } from "react";
              import { MDBSelect } from "mdbreact";
              
              class SelectPage extends Component {
                state = {
                  options: [
                    {
                      text: "Option 1",
                      value: "1"
                    },
                    {
                      text: "Option 2",
                      value: "2"
                    },
                    {
                      text: "Option 3",
                      value: "3"
                    }
                  ]
                };
              
                render() {
                  return (
                    <div>
                      <MDBSelect
                        options={this.state.options}
                        selected="Choose your option"
                        label="Example label"
                      />
                    </div>
                  );
                }
              }
              
              export default SelectPage;
           
        
    

Select with markup usage MDB Pro component

You can bind options data from object and have full control of select component, or you can use select with markup based on HTML. This solution offers a little bit less control over the component - it won't respond on outer options changes (f.e. deletion, sorting or keyboard control).

        
            
          import React, { Component } from "react";
          import { MDBSelect, MDBSelectInput, MDBSelectOptions, MDBSelectOption } from "mdbreact";
  
          class SelectPage extends Component {
            render() {
              return (
                <div>
                  <MDBSelect label="Example label">
                    <MDBSelectInput selected="Choose your country" />
                    <MDBSelectOptions>
                      <MDBSelectOption disabled>Choose your country</MDBSelectOption>
                      <MDBSelectOption value="1">USA</MDBSelectOption>
                      <MDBSelectOption value="2">Germany</MDBSelectOption>
                      <MDBSelectOption value="3">France</MDBSelectOption>
                      <MDBSelectOption value="4">Poland</MDBSelectOption>
                      <MDBSelectOption value="5">Japan</MDBSelectOption>
                    </MDBSelectOptions>
                  </MDBSelect>
                </div>
              );
            }
          }
  
          export default SelectPage;
        
        
    

Color variations MDB Pro component

In order to change a select color use property color.

        
            
          import React, { Component } from "react";
          import { MDBSelect } from "mdbreact";
          
          class SelectPage extends Component {
            state = {
              options: [
                {
                  text: "Option 1",
                  value: "1"
                },
                {
                  text: "Option 2",
                  value: "2"
                },
                {
                  text: "Option 3",
                  value: "3"
                },
                {
                  text: "Option 4",
                  value: "4"
                },
                {
                  text: "Option 5",
                  value: "5"
                }
              ]
            };
          
            render() {
              return (
                <div>
                  <MDBSelect
                    options={this.state.options}
                    selected="Choose your option"
                    color="primary"
                    label="Example label"
                  />
                </div>
              );
            }
          }
          
          export default SelectPage;
      
        
    
        
            
        import React, { Component } from "react";
        import { MDBSelect, MDBSelectInput, MDBSelectOptions, MDBSelectOption } from "mdbreact";

        class SelectPage extends Component {
          render() {
            return (
              <div>
                <MDBSelect color="primary" label="Example label">
                  <MDBSelectInput selected="Choose your option" />
                  <MDBSelectOptions>
                    <MDBSelectOption disabled>Choose your option</MDBSelectOption>
                    <MDBSelectOption value="1">Option nr 1</MDBSelectOption>
                    <MDBSelectOption value="2">Option nr 2</MDBSelectOption>
                    <MDBSelectOption value="3">Option nr 3</MDBSelectOption>
                    <MDBSelectOption value="4">Option nr 4</MDBSelectOption>
                    <MDBSelectOption value="5">Option nr 5</MDBSelectOption>
                  </MDBSelectOptions>
                </MDBSelect>
              </div>
            );
          }
        }

        export default SelectPage;
        
        
    


Preselected options MDB Pro component

Use property checked on an MDBSelectOption element to preselect it while component renders.

        
            
        import React, { Component } from "react";
        import { MDBSelect } from "mdbreact";

        class SelectPage extends Component {
          state = {
            options: [
              {
                text: "Option nr 1",
                value: "1"
              },
              {
                text: "Option nr 2",
                value: "2"
              },
              {
                checked: true,
                text: "Option nr 3",
                value: "3"
              },
              {
                text: "Option nr 4",
                value: "4"
              },
              {
                text: "Option nr 5",
                value: "5"
              }
            ]
          };

          render() {
            return (
              <div>
                <MDBSelect
                  search
                  options={this.state.options}
                  selected="Choose your option"
                  label="Example label"
                />
              </div>
            );
          }
        }

        export default SelectPage;
      
        
    
        
            
        import React, { Component } from "react";
        import { MDBSelect, MDBSelectInput, MDBSelectOptions, MDBSelectOption } from "mdbreact";

        class SelectPage extends Component {
          render() {
            return (
              <div>
                <MDBSelect label="Example label">
                  <MDBSelectInput selected="Choose your option" />
                  <MDBSelectOptions>
                    <MDBSelectOption disabled>Choose your option</MDBSelectOption>
                    <MDBSelectOption value="1">Option nr 1</MDBSelectOption>
                    <MDBSelectOption value="2">Option nr 2</MDBSelectOption>
                    <MDBSelectOption value="3" selected>Option nr 3</MDBSelectOption>
                    <MDBSelectOption value="4">Option nr 4</MDBSelectOption>
                    <MDBSelectOption value="5">Option nr 5</MDBSelectOption>
                  </MDBSelectOptions>
                </MDBSelect>
              </div>
            );
          }
        }

        export default SelectPage;
      
        
    

Option groups MDB Pro component

Separate groups of options using disabled option.

        
            
        import React, { Component } from "react";
        import { MDBSelect } from "mdbreact";

        class SelectPage extends Component {
          state = {
            options: [
              {
                disabled: true,
                text: "team 1"
              },
              {
                text: "Option 1",
                value: "1"
              },
              {
                text: "Option 2",
                value: "2"
              },
              {
                disabled: true,
                text: "team 2"
              },
              {
                checked: true,
                text: "Option 3",
                value: "3"
              },
              {
                text: "Option 4",
                value: "4"
              }
            ]
          };

          render() {
            return (
              <div>
                <MDBSelect
                  options={this.state.options}
                  selected="Choose your option"
                  label="Example label"
                />
              </div>
            );
          }
        }

        export default SelectPage;
      
        
    
        
            
        import React, { Component } from "react";
        import { MDBSelect, MDBSelectInput, MDBSelectOptions, MDBSelectOption } from "mdbreact";

        class SelectPage extends Component {
          render() {
            return (
              <div>
                <MDBSelect label="Example label">
                  <MDBSelectInput selected="Choose your option" />
                  <MDBSelectOptions>
                    <MDBSelectOption disabled>team 1</MDBSelectOption>
                    <MDBSelectOption value="1">Option 1</MDBSelectOption>
                    <MDBSelectOption value="2">Option 2</MDBSelectOption>
                    <MDBSelectOption separator>team 2</MDBSelectOption>
                    <MDBSelectOption value="3">Option 3</MDBSelectOption>
                    <MDBSelectOption value="4">Option 4</MDBSelectOption>
                  </MDBSelectOptions>
                </MDBSelect>
              </div>
            );
          }
        }

        export default SelectPage;
        
        
    

Select with icons MDB Pro component

Beautify your select and use icons inside option components.

        
            
        import React, { Component } from "react";
        import { MDBSelect } from "mdbreact";

        class SelectPage extends Component {
          state = {
            options: [
              {
                icon: "https://mdbootstrap.com/img/Photos/Avatars/avatar-1.webp",
                value: "example 1",
                text: "User nr 1"
              },
              {
                icon: "https://mdbootstrap.com/img/Photos/Avatars/avatar-2.webp",
                value: "example 2",
                text: "User nr 2"
              },
              {
                icon: "https://mdbootstrap.com/img/Photos/Avatars/avatar-3.webp",
                value: "example 3",
                text: "User nr 3",
              }
            ]
          };

          render() {
            return (
              <div>
                <MDBSelect
                  options={this.state.options}
                  selected="Choose your option"
                  label="Example label"
                />
              </div>
            );
          }
        }

        export default SelectPage;
      
        
    
        
            
        import React, { Component } from "react";
        import { MDBSelect, MDBSelectInput, MDBSelectOptions, MDBSelectOption } from "mdbreact";

        class SelectPage extends Component {
          render() {
            return (
              <div>
                <MDBSelect label="Example label">
                  <MDBSelectInput selected="Choose your option" />
                  <MDBSelectOptions>
                      <MDBSelectOption disabled>Choose your option</MDBSelectOption>
                      <MDBSelectOption
                        value="example 1"
                        icon="https://mdbootstrap.com/img/Photos/Avatars/avatar-1.webp"
                      >
                        User nr 1
                      </MDBSelectOption>
                      <MDBSelectOption
                        value="example 2"
                        icon="https://mdbootstrap.com/img/Photos/Avatars/avatar-2.webp"
                      >
                        User nr 2
                      </MDBSelectOption>
                      <MDBSelectOption
                        value="example 3"
                        icon="https://mdbootstrap.com/img/Photos/Avatars/avatar-3.webp"
                      >
                        User nr 3
                      </MDBSelectOption>
                    </MDBSelectOptions>
                </MDBSelect>
              </div>
            );
          }
        }

        export default SelectPage;
        
        
    

Disabled select option MDB Pro component

By adding a disabled attribute to the particular option, you can make it unselectable.

        
            
        import React, { Component } from "react";
        import { MDBSelect } from "mdbreact";

        class SelectPage extends Component {
          state = {
            options: [
              {
                disabled: true,
                text: "Disabled option",
                value: "1"
              },
              {
                text: "Option nr 2",
                value: "2"
              },
              {
                text: "Option nr 3",
                value: "3"
              }
            ]
          };

          render() {
            return (
              <div>
                <MDBSelect
                  options={this.state.options}
                  selected="Choose your option"
                  label="Example label"
                />
              </div>
            );
          }
        }

        export default SelectPage;
      
        
    
        
            
        import React, { Component } from "react";
        import { MDBSelect, MDBSelectInput, MDBSelectOptions, MDBSelectOption } from "mdbreact";

        class SelectPage extends Component {
          render() {
            return (
              <div>
                <MDBSelect label="Example label">
                  <MDBSelectInput selected="Choose your option" />
                  <MDBSelectOptions>
                    <MDBSelectOption disabled>Choose your option</MDBSelectOption>
                    <MDBSelectOption value="1" disabled>Disabled option</MDBSelectOption>
                    <MDBSelectOption value="2">Option nr 2</MDBSelectOption>
                    <MDBSelectOption value="3">Option nr 3</MDBSelectOption>
                  </MDBSelectOptions>
                </MDBSelect>
              </div>
            );
          }
        }

        export default SelectPage;
        
        
    

Select Multiple MDB Pro component

Setting property multiple allows to select the list of options. For complex options, check Multiselect documentation

Note: Select All option is available only within Select with Object based options.

        
            
        import React, { Component } from "react";
        import { MDBSelect } from "mdbreact";

        class SelectPage extends Component {
          state = {
            options: [
              {
                text: "Option nr 1",
                value: "1"
              },
              {
                text: "Option nr 2",
                value: "2"
              },
              {
                text: "Option nr 3",
                value: "3"
              }
            ]
          };

          render() {
            return (
              <div>
                <MDBSelect
                  multiple
                  options={this.state.options}
                  selected="Choose your option"
                  label="Example label"
                />
              </div>
            );
          }
        }

        export default SelectPage;
      
        
    
        
            
        import React from "react";
        import { MDBSelect, MDBSelectInput, MDBSelectOptions, MDBSelectOption } from "mdbreact";

        const SelectPage = () => {
          return (
            <div>
              <MDBSelect multiple label="Example label">
                <MDBSelectInput selected="Choose your option" />
                <MDBSelectOptions>
                  <MDBSelectOption disabled>Choose your option</MDBSelectOption>
                  <MDBSelectOption value="1">Option nr 1</MDBSelectOption>
                  <MDBSelectOption value="2">Option nr 2</MDBSelectOption>
                  <MDBSelectOption value="3">Option nr 3</MDBSelectOption>
                </MDBSelectOptions>
              </MDBSelect>
            </div>
          );
        }

        export default SelectPage;
        
        
    

React Select - API

In this section you will find advanced information about the Select component. You will find out which modules are required, what are the possibilities of configuring the component, and what events and methods you can use to work with it.


Imports

        
            
          import React from 'react';
          import { MDBSelect, MDBSelectInput, MDBSelectOptions, MDBSelectOption } from 'mdbreact';
        
        
    

Usage

There are two ways to bind your data into Select.
You can use regular JSX/HTML markup, or build an Array of object structured data.

        
            
          import React, { Component } from "react";
          import { MDBSelect } from "mdbreact";
    
          class SelectPage extends Component {
            state = {
              options: [
                {
                  checked: false,
                  disabled: false,
                  icon: null,
                  value: "1",
                  text: "Option 1"
                },
                {
                  checked: false,
                  disabled: false,
                  icon: null,
                  value: "2",
                  text: "Option 2"
                },
                {
                  checked: false,
                  disabled: false,
                  icon: null,
                  value: "3",
                  text: "Option 3"
                }
              ]
            };
    
            render() {
              return (
                <div>
                  <MDBSelect
                      multiple
                      options={this.state.options}
                      selected="Choose your option"
                  />
                  <label>Example label</label>
                </div>
              );
            }
          }
    
          export default SelectPage;
        
        
    
        
            
          import React, { Component } from "react";
          import { MDBSelect, MDBSelectInput, MDBSelectOptions, MDBSelectOption } from "mdbreact";
    
          class SelectPage extends Component {
            render() {
              return (
                <div>
                  <MDBSelect>
                    <MDBSelectInput selected="Choose your option" />
                    <SelectOptions>
                      <MDBSelectOption disabled>Choose your option</MDBSelectOption>
                      <MDBSelectOption value="1">Option nr 1</MDBSelectOption>
                      <MDBSelectOption value="2">Option nr 2</MDBSelectOption>
                      <MDBSelectOption value="3">Option nr 3</MDBSelectOption>
                    </MDBSelectOptions>
                  </MDBSelect>
                  <label>Example label</label>
                </div>
              );
            }
          }
    
          export default SelectPage;
        
        
    

API Reference: Select Properties

The table below shows the configuration options of the MDBSelect component.

Name Type Default Description Example
className String "select-wrapper md-form mdb-select" Select wrapper classes. <MDBSelect className="my-custom-class">
color String Sets colorfull hover efect on select options. <MDBSelect color="primary">
label String Sets animated label for the select input. <MDBSelect label="Example label">
labelClass String Sets custom class for select label (f.e. to change background color). <MDBSelect labelClass="customClass">
multiple Boolean false Allows to select multiple options. <MDBSelect multiple={true}>
options Array(Object) [] Sets options array as source of data. This property is used in alternative Select version. <MDBSelect options={this.state.options} />
outline Boolean false Switch outline mode - Material 2.0 design with outlines and animated label. <MDBSelect outline />
Next properties works only for Select with data Array!
required Boolean false Makes select required when submitting form. <MDBSelect required >
search Boolean false Search element will appear as the firs child of select. <MDBSelect search={true}>
searchLabel String Search Changes default label of additional search element. <MDBSelect searchLabel="Find option" />
searchId String selectSearchInput Changes default id of additional search element. <MDBSelect searchId="id" />
selected String Set default select text content. <MDBSelect selected="Choose option" >
selectAll Boolean false Enables Select All button. <MDBSelect selectAll >
selectAllClassName String Sets custom class for select all option (f.e. to change font weight). <MDBSelect selectAllClassName="customClass" >
selectAllLabel String "Select All" Sets text for Select All button. <MDBSelect selectAllLabel="Select All" >
selectAllValue String "0" Sets value for Select All button. <MDBSelect selectAllValue="0" >
focusBackgroundColor String "#eee" Sets background-color for focused option. <MDBSelect focusBackgroundColor="#eee" >
focusShadow String "inset 0px -17px 15px -16px rgba(0, 0, 0, 0.35)" Sets box-shadow for focused option. <MDBSelect focusShadow="inset 0px -17px 15px -16px rgba(0, 0, 0, 0.35)" >

API Reference: Select Methods

Name Parameters Description Example
getTextContent Returns input text content. Use this method to get string with selected options. <MDBSelect getTextContent={this.handleSelectChange} >
getValue Returns Select value. Use this method to get array with selected options. <MDBSelect getValue={this.handleSelectChange} >

API Reference: SelectInput Properties

The table below shows the configuration options of the MDBSelectInput component.

Name Type Default Description Example
className String Sets custom classes. <MDBSelectInput className="customClass" >
selected String Works only with Select with markup! Set default select text content. <MDBSelect selected="Choose option" >

API Reference: SelectOptions Properties

The table below shows the configuration options of the MDBSelectOptions component.

Name Type Default Description Example
className String Sets custom classes. <MDBSelectOptions className="customClass" >
search Boolean false Search element will appear as the firs child of select. <MDBSelectOptions search >
searchLabel String Search Changes default label of additional search element. <MDBSelectOptions searchLabel="Find option" />
searchId String selectSearchInput Changes default id of additional search element. <MDBSelectOptions searchId="id" />

API Reference: SelectOption Properties

The table below shows the configuration options of the MDBSelectOption component.

Name Type Default Description Example
checked Boolean false If true - the option will be preselected during mount. <MDBSelectOption checked >
className String Sets custom classes. <MDBSelectOption className="customClass" >
disabled Boolean false If true - the option wont be clickable. <MDBSelectOption disabled >
separator Boolean false If true - adds top border (sets disabled to true). <MDBSelectOption separator >
icon String Inserts icon into select option. <MDBSelectOption icon="icon_url" >
value String Sets option value (you can still use text content - value will be readable in getValue method). <MDBSelectOption value="option 1" >

API Reference: Options Array Structure

The table below shows the configuration options as an list of objects for alternative Select.

Name Type Default Description Example
checked Boolean If true - the option will be preselected during mount. { checked: true }
disabled Boolean If true - the option wont be clickable. { disabled: true }
icon String Inserts icon into select option. { icon="icon_url" }
text String Sets option text content. { text: "Option one" }
value String Sets option value. { value: "1" }